#include <gtk/gtk.h>

#define NB_THREADS 5

GThread *threads[NB_THREADS];

static gpointer
thread_run_func (gpointer data)
{
	g_print ("Started thread %d, going to sleep...\n", GPOINTER_TO_INT (data));
	g_usleep (2000000);
	g_print ("Terminated thread %d\n", GPOINTER_TO_INT (data));
	threads [GPOINTER_TO_INT (data)] = NULL;
	return NULL;
}

static void
run_thread_cb (GtkWidget *widget, gpointer data)
{
    g_print ("Running threads\n");
    gint i;
    for (i = 0; i < NB_THREADS; i++) {
	    if (threads[i])
		    continue;
	    threads[i] = g_thread_create ((GThreadFunc) thread_run_func, GINT_TO_POINTER (i), FALSE, NULL);
    }
}

static gboolean
delete_event (GtkWidget *widget, GdkEvent  *event, gpointer   data)
{
    return TRUE;
}

static void
destroy (GtkWidget *widget, gpointer   data)
{
    gtk_main_quit ();
}

int
main (int   argc, char *argv[])
{
    GtkWidget *window;
    GtkWidget *button;
    
    gtk_init (&argc, &argv);
    g_thread_init (NULL);
    
    memset (threads, 0, sizeof (GThread*) * NB_THREADS);

    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    g_signal_connect (G_OBJECT (window), "delete_event",
		      G_CALLBACK (delete_event), NULL);
    g_signal_connect (G_OBJECT (window), "destroy",
		      G_CALLBACK (destroy), NULL);
    gtk_container_set_border_width (GTK_CONTAINER (window), 10);
    button = gtk_button_new_with_label ("Run threads");
    g_signal_connect (G_OBJECT (button), "clicked",
		      G_CALLBACK (run_thread_cb), NULL);
    gtk_container_add (GTK_CONTAINER (window), button);
    gtk_widget_show (button);
    
    /* and the window */
    gtk_widget_show (window);
    
    gtk_main ();
    
    return 0;
}
